; *************************************
; PIC1684 Header file 
; Equates section (defining memory locations for ports etc)
; The number after 'equ' is for an internal number/address for that function
;
; Source code written by Kristian Mason, probably in 2009, all rights reserved no doubt.
;
; anyway let's declare some registers!
;

	LIST P=16F84A 
	#include	<p16F84A.inc>
 	errorlevel	-302
ZEROBIT		EQU	2
COUNT		EQU	0CH ; a register to count events

;configure assembler to use pic processor
	
	ORG 0
	GOTO START ; go to start!


; configure the pic itself
	__CONFIG H'3FF0' ; hexidecimal to select LP oscillator (not power hungry, low frequency operation), WDT off, PUT on and disable code protection;


;************************
; Common subroutines - add some subroutines/code functions here to enjoy at a later line

;routine one - one second delay - assumes pic is running on a 32khz crystal.
DELAY1 	CLRF 	TMR0 ;START + clear TMR0
LOOPA  	MOVF 	TMR0,W ;READ TMR0 INTO WORKING REGISTER *YIKES!*
       	SUBLW 	.32 ;TIME -32
       	BTFSS 	STATUS,ZEROBIT
       	GOTO 	LOOPA
       	RETLW 	0
;************************


;**********************************************************
; CONFIG SECTION - TIME TO SET OUR PINS AND TIMING SETTINGS
;**********************************************************

START BSF STATUS,5 ;TURNS TO BANK1
      MOVLW B'00000000' ; PUT THAT BINARY INTO WORKING REGISTER
      MOVWF TRISA ;AND THEN PUT IT INTO TRISA AND NOW FOR PORTB:
      MOVLW B'00000000'
      MOVWF TRISB
      
	  MOVLW B'00000111' ;FOR AN UNKNOWN REASON THIS MAKES THE TIMER PRESCALER /256
      MOVWF OPTION_REG ; TIMER IS 1/36 SECS
     
	BCF STATUS,5 ; RETURN TO BANK 0
	CLRF PORTA ; FLUSH PORTA 
	CLRF PORTB ; CLEAR PORTB

; ___________________________________________________________________________________________________________________________
      
   
;*********************************************************
;*********************************************************
;*********************************************************
; WE CAN START THE PROGRAM! HURRAH!***********************
; OVER TO YOU NOW SQUIRE!*********************************
;*********************************************************
BEGIN
; set a pin on port A to high then delay
	MOVLW B'00000001'
	MOVWF PORTA
	CALL DELAY1
; and clear port A again and repeat:
	MOVLW B'00000000'
	MOVWF PORTA
	CALL DELAY1

	GOTO BEGIN


;Call a halt to the program - let's call it a day
	END